"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const _assignValue = require("./_assignValue.js");
const _castPath = require("./_castPath.js");
const _isIndex = require("./_isIndex.js");
const isObject$1 = require("./isObject.js");
const _toKey = require("./_toKey.js");
var assignValue = _assignValue._assignValue, castPath = _castPath._castPath, isIndex = _isIndex._isIndex, isObject = isObject$1.isObject_1, toKey = _toKey._toKey;
function baseSet(object, path, value, customizer) {
  if (!isObject(object)) {
    return object;
  }
  path = castPath(path, object);
  var index = -1, length = path.length, lastIndex = length - 1, nested = object;
  while (nested != null && ++index < length) {
    var key = toKey(path[index]), newValue = value;
    if (key === "__proto__" || key === "constructor" || key === "prototype") {
      return object;
    }
    if (index != lastIndex) {
      var objValue = nested[key];
      newValue = customizer ? customizer(objValue, key, nested) : void 0;
      if (newValue === void 0) {
        newValue = isObject(objValue) ? objValue : isIndex(path[index + 1]) ? [] : {};
      }
    }
    assignValue(nested, key, newValue);
    nested = nested[key];
  }
  return object;
}
var _baseSet = baseSet;
exports._baseSet = _baseSet;
